---

---

<div class="bouncing-blobs-container">
  <div class="bouncing-blobs-glass"></div>
  <div class="bouncing-blobs">
	<div class="bouncing-blob bouncing-blob--blue"></div>
	<div class="bouncing-blob bouncing-blob--blue"></div>
	<div class="bouncing-blob bouncing-blob--blue"></div>
	<div class="bouncing-blob bouncing-blob--white"></div>
	<div class="bouncing-blob bouncing-blob--purple"></div>
	<div class="bouncing-blob bouncing-blob--purple"></div>
	<div class="bouncing-blob bouncing-blob--purple"></div>
	<div class="bouncing-blob bouncing-blob--purple"></div>
	<div class="bouncing-blob bouncing-blob--pink"></div>
	<div class="bouncing-blob bouncing-blob--pink"></div>
	<div class="bouncing-blob bouncing-blob--pink"></div>
	<div class="bouncing-blob bouncing-blob--pink"></div>
	<div class="bouncing-blob bouncing-blob--white"></div>
  </div>
</div>

<style>
.bouncing-blob {
  width: 40vw;
  aspect-ratio: 1;
  border-radius: 50%;
  will-change: transform;
  position: absolute;
  z-index: 1;
  top: 0;
  left: 0;
  transform-origin: left top;
}

.bouncing-blob--blue {
  background: #283dfa;
}

.bouncing-blob--white {
  background: #fcfcfc;
  z-index: 2;
  width: 15vw;
}

.bouncing-blob--purple {
  background: #8c34fa;
}

.bouncing-blob--pink {
  background: #1ba7fa;
}

.bouncing-blobs-container {
  position: absolute;
  z-index: -1;
  top: 0;
  left: 0;
  width: 100%;
  height: 100%;
}

.bouncing-blobs-glass {
  position: absolute;
  background-color: #04050b55;
  z-index: 2;
  top: 0;
  left: 0;
  width: 100%;
  height: 100%;
  backdrop-filter: blur(140px);
  -webkit-backdrop-filter: blur(140px);
  pointer-events: none;
}

.bouncing-blobs {
  position: absolute;
  z-index: 1;
  top: 0;
  left: 0;
  width: 100%;
  height: 100%;
}

</style>
	<script is:inline>

		const MIN_SPEED = 0.5
		const MAX_SPEED = 0.5

		function randomNumber(min, max) {
		  return Math.random() * (max - min) + min
		}

		class Blob {
		  constructor(el) {
			this.el = el
			const boundingRect = this.el.getBoundingClientRect()
			this.size = boundingRect.width
			this.initialX = randomNumber(0, window.innerWidth - this.size)
			this.initialY = randomNumber(0, window.innerHeight - this.size)
			this.el.style.top = `${this.initialY}px`
			this.el.style.left = `${this.initialX}px`
			this.vx =
			  randomNumber(MIN_SPEED, MAX_SPEED) * (Math.random() > 0.5 ? 1 : -1)
			this.vy =
			  randomNumber(MIN_SPEED, MAX_SPEED) * (Math.random() > 0.5 ? 1 : -1)
			this.x = this.initialX
			this.y = this.initialY
		  }

		  update() {
			this.x += this.vx
			this.y += this.vy
			if (this.x >= window.innerWidth - this.size) {
			  this.x = window.innerWidth - this.size
			  this.vx *= -1
			}
			if (this.y >= window.innerHeight - this.size) {
			  this.y = window.innerHeight - this.size
			  this.vy *= -1
			}
			if (this.x <= 0) {
			  this.x = 0
			  this.vx *= -1
			}
			if (this.y <= 0) {
			  this.y = 0
			  this.vy *= -1
			}
		  }

		  move() {
			this.el.style.transform = `translate(${this.x - this.initialX}px, ${
			  this.y - this.initialY
			}px)`
		  }
		}

		function initBlobs() {
		  const blobEls = document.querySelectorAll('.bouncing-blob')
		  const blobs = Array.from(blobEls).map((blobEl) => new Blob(blobEl))

		  function update() {
			requestAnimationFrame(update)
			blobs.forEach((blob) => {
			  blob.update()
			  blob.move()
			})
		  }

		  requestAnimationFrame(update)
		}

		initBlobs()


	</script>
